					EXPORT	LINEDDA_STAR_DEMO_VRAM
					EXPORT	LINEDDA_STAR_DEMO_MODE
					EXPORT	LINEDDA_STAR_DEMO_X0
					EXPORT	LINEDDA_STAR_DEMO_Y0

					EXPORT	LINEDDA_STAR_DEMO
					EXPORT	LINEDDA_STAR_DEMO_INIT
					EXPORT	LINEDDA_STAR_DEMO_ONESTEP
					EXPORT	LINEDDA_STAR_DEMO_CLEANUP
					EXPORT	LINEDDA_STAR_DEMO_OVER


LINEDDA_STAR_DEMO_COUNT	FCB	0
LINEDDA_STAR_DEMO_OVER	FCB	0

LINEDDA_STAR_DEMO
					PSHS	A,B,X,Y,U

					BSR		LINEDDA_STAR_DEMO_INIT
LINEDDA_STAR_DEMO_LOOP
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_STAR_DEMO_LOOP_END

					BSR		LINEDDA_STAR_DEMO_ONESTEP
					TST		LINEDDA_STAR_DEMO_OVER,PCR
					BEQ		LINEDDA_STAR_DEMO_LOOP
					LBSR	LINEDDA_STAR_DEMO_CLEANUP
LINEDDA_STAR_DEMO_LOOP_END
					PULS	A,B,X,Y,U
					RTS


LINEDDA_STAR_DEMO_INIT
					PSHS	A,B
					LBSR	INSTALL_LINEDDA_IN_SUBCPU
					LBSR	INSTALL_CLEAR_BITPLANE_IN_SUBCPU

					CLR		LINEDDA_STAR_DEMO_OVER,PCR
					CLR		LINEDDA_STAR_DEMO_COUNT,PCR
					CLRA
					CLRB
					STD		LINEDDA_STAR_DEMO_VRAM,PCR
					PULS	A,B,PC


LINEDDA_STAR_DEMO_ONESTEP
					PSHS	A,B,X,Y,U

					LDU		LINEDDA_STAR_DEMO_VRAM,PCR

					LDX		#639
					STX		RANDOM_NUMBER_RANGE
					LBSR	GET_RANDOM_IN_RANGE
					LDX		RANDOM_NUMBER,PCR
					STX		LINEDDA_STAR_DEMO_X0,PCR

					LDX		#199
					STX		RANDOM_NUMBER_RANGE
					LBSR	GET_RANDOM_IN_RANGE
					LDX		RANDOM_NUMBER,PCR
					STX		LINEDDA_STAR_DEMO_Y0,PCR

					LDA		#1
					STA		LINEDDA_STAR_DEMO_MODE,PCR

					BSR		LINEDDA_STAR_DEMO_MAIN

					LEAU	$4000,U
					CMPU	#$8000
					BCS		LINEDDA_STAR_DEMO_REPEAT_LOOP_NEXT
					BEQ		LINEDDA_STAR_DEMO_REPEAT_LOOP_NEXT
					LDU		#0
LINEDDA_STAR_DEMO_REPEAT_LOOP_NEXT
					STU		LINEDDA_STAR_DEMO_VRAM,PCR
					INC		LINEDDA_STAR_DEMO_COUNT,PCR
					LDA		LINEDDA_STAR_DEMO_COUNT,PCR
					CMPA	#8
					BLO		LINEDDA_STAR_DEMO_ONESTEP_DONE
					STA		LINEDDA_STAR_DEMO_OVER,PCR
LINEDDA_STAR_DEMO_ONESTEP_DONE
					PULS	A,B,X,Y,U,PC


LINEDDA_STAR_DEMO_CLEANUP
					RTS


LINEDDA_STAR_DEMO_VRAM	RZB 2
LINEDDA_STAR_DEMO_MODE	RZB 1
LINEDDA_STAR_DEMO_X0	RZB	2
LINEDDA_STAR_DEMO_Y0	RZB	2

LINEDDA_STAR_DEMO_MAIN
					PSHS	A,B,X,U

					LDU		#LINEDDA_IN_SUBCPU_BUFFER

					LDX		LINEDDA_STAR_DEMO_VRAM,PCR
					STX		,U++

					LDA		#80
					STA		,U+

					LDA		LINEDDA_STAR_DEMO_MODE,PCR
					STA		,U+

					TFR		U,Y

					CLR		,U+

					LDX		#8
LINEDDA_STAR_DEMO_LOOP1
					LDD		LINEDDA_STAR_DEMO_X0,PCR
					STD		,U++
					LDD		LINEDDA_STAR_DEMO_Y0,PCR
					STB		,U+

					STX		,U++
					LDB		#190
					STB		,U+

					INC		,Y

					LEAX	17,X
					CMPX	#630
					BLE		LINEDDA_STAR_DEMO_LOOP1


					LDA		#190
LINEDDA_STAR_DEMO_LOOP2
					LDX		LINEDDA_STAR_DEMO_X0,PCR
					STX		,U++
					LDB		LINEDDA_STAR_DEMO_Y0+1,PCR
					STB		,U+

					LDX		#630
					STX		,U++
					STA		,U+

					INC		,Y

					SUBA	#11
					CMPA	#10
					BCC		LINEDDA_STAR_DEMO_LOOP2


					LDX		#630
LINEDDA_STAR_DEMO_LOOP3
					LDD		LINEDDA_STAR_DEMO_X0,PCR
					STD		,U++
					LDD		LINEDDA_STAR_DEMO_Y0,PCR
					STB		,U+

					STX		,U++
					LDB		#10
					STB		,U+

					INC		,Y

					LEAX	-17,X
					CMPX	#10
					BGE		LINEDDA_STAR_DEMO_LOOP3


					LDA		#10
LINEDDA_STAR_DEMO_LOOP4
					LDX		LINEDDA_STAR_DEMO_X0,PCR
					STX		,U++
					LDB		LINEDDA_STAR_DEMO_Y0+1,PCR
					STB		,U+

					LDX		#10
					STX		,U++
					STA		,U+

					INC		,Y

					ADDA	#11
					CMPA	#190
					BCS		LINEDDA_STAR_DEMO_LOOP4


					LDX		#LINEDDA_IN_SUBCPU_BUFFER
					TFR		U,D
					SUBD	#LINEDDA_IN_SUBCPU_BUFFER
					BSR		LINEDDA_STAR_DEMO_RUN

					PULS	A,B,X,U
					RTS


LINEDDA_STAR_DEMO_RUN
					; X Buffer Location
					; D Length

					; $FD37
					; Bit7 Bit6 Bit5 Bit4 Bit3 Bit2 Bit1 Bit0
					;      CRTC CRTC CRTC       CPU  CPU  CPU
					;         G    R    B         G    R    B
					; 1:Disable  0:Enable
					;LDA		#$20	; VRAM access control
					;STA		$FD37

					STX		CALL_LINEDDA_SUBCPU_DATAADDR,PCR
					LBSR	CALL_CLS_AND_LINEDDA_SUBCPU

					;LDA		#$0	; VRAM access control
					;STA		$FD37

					RTS
