					EXPORT		CUBE_DEMO
					EXPORT		CUBE_DEMO_INIT
					EXPORT		CUBE_DEMO_ONESTEP
					EXPORT		CUBE_DEMO_CLEANUP
					EXPORT		CUBE_DEMO_OVER

CUBE_DEMO_OVER		FCB			0

; See geometry.asm for data format.
CUBE_DATA			FCB			8		; 8 Vertices
					FDB			-100,-100,-100
					FDB			 100,-100,-100
					FDB			 100, 100,-100
					FDB			-100, 100,-100
					FDB			-100,-100, 100
					FDB			 100,-100, 100
					FDB			 100, 100, 100
					FDB			-100, 100, 100
					FCB			12		; 12 edges
					FCB			0,1, 1,2, 2,3, 3,0
					FCB			0,4, 1,5, 2,6, 3,7
					FCB			4,5, 5,6, 6,7, 7,4

CUBE_VTX_TFMBUF		FDB			-100,-100,-100
					FDB			 100,-100,-100
					FDB			 100, 100,-100
					FDB			-100, 100,-100
					FDB			-100,-100, 100
					FDB			 100,-100, 100
					FDB			 100, 100, 100
					FDB			-100, 100, 100

CUBE_DEMO_VRAMADDR	FDB		0
CUBE_DEMO_VX		FCB		8
CUBE_DEMO_CTR		FCB		0

CUBE_DEMO			PSHS	A,B,X,Y,U,CC
					ORCC	#$40

					BSR		CUBE_DEMO_INIT
CUBE_DEMO_LOOP		BSR		CUBE_DEMO_ONESTEP
					LDA		$FD04
					BITA	#2
					BEQ		CUBE_DEMO_LOOP_OUT
					TST		CUBE_DEMO_OVER,PCR
					BEQ		CUBE_DEMO_LOOP
					BSR		CUBE_DEMO_CLEANUP

CUBE_DEMO_LOOP_OUT
					PULS	A,B,X,Y,U,CC
					RTS


CUBE_DEMO_INIT		PSHS	A,B,X,Y,U

					CLR		CUBE_DEMO_OVER,PCR
					CLR		CUBE_DEMO_CTR,PCR
					CLR		CUBE_DEMO_USEPLT,PCR

					LBSR	INSTALL_LINEDDA_IN_SUBCPU
					LBSR	INSTALL_CLEAR_BITPLANE_IN_SUBCPU

					LBSR	CLEAR_SCREEN

					LDX		#0
					STX		TRANS3D_OBJX,PCR
					STX		TRANS3D_OBJY,PCR
					STX		TRANS3D_OBJZ,PCR
					STX		TRANS3D_VIEWX,PCR
					STX		TRANS3D_VIEWY,PCR
					LDX		#300
					STX		TO_SCREEN_TRANS3D_VIEWZ,PCR

					LDX		#$4000
					STX		CUBE_DEMO_VRAMADDR,PCR

					CLR		$FD38
					CLR		$FD39
					CLR		$FD3A
					CLR		$FD3B
					CLR		$FD3C
					CLR		$FD3D
					CLR		$FD3E
					CLR		$FD3F
					PULS	A,B,X,Y,U,PC


CUBE_DEMO_CLEANUP	RTS


CUBE_DEMO_ONESTEP	PSHS	A,B,X,Y,U

					LDA		CUBE_DEMO_CTR,PCR
					CMPA	#50
					BEQ		CUBE_DEMO_SWITCH_TO_MODE2
					BGT		CUBE_DEMO_MODESET
					LDA		#1
					STA		CUBE_DEMO_USEPLT,PCR
					BRA		CUBE_DEMO_MODESET

CUBE_DEMO_SWITCH_TO_MODE2
					CLR		CUBE_DEMO_USEPLT,PCR
					CLRA
					LDX		#$FD38
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
CUBE_DEMO_MODESET
					BSR		CUBE_DEMO_MAIN

					INC		CUBE_DEMO_CTR,PCR
					LDA		CUBE_DEMO_CTR,PCR
					CMPA	#100
					BLT		CUBE_DEMO_ONESTEP_OVER
					INC		CUBE_DEMO_OVER,PCR
CUBE_DEMO_ONESTEP_OVER
					PULS	A,B,X,Y,U,PC


CUBE_DEMO_USEPLT	FCB		0
CUBE_DEMO_MAIN		PSHS	A,B,X,Y,U

					LDA		TO_SCREEN_TRANS3D_OBJH,PCR
					ADDA	#2
					STA		TO_SCREEN_TRANS3D_OBJH,PCR
					LDA		TO_SCREEN_TRANS3D_OBJP,PCR
					ADDA	#4
					STA		TO_SCREEN_TRANS3D_OBJP,PCR
					LDA		TO_SCREEN_TRANS3D_OBJB,PCR
					ADDA	#1
					STA		TO_SCREEN_TRANS3D_OBJB,PCR
					LDX		#0
					STX		TO_SCREEN_TRANS3D_VIEWX,PCR
					STX		TO_SCREEN_TRANS3D_VIEWY,PCR
					CLR		TO_SCREEN_TRANS3D_VIEWH,PCR
					CLR		TO_SCREEN_TRANS3D_VIEWP,PCR
					CLR		TO_SCREEN_TRANS3D_VIEWB,PCR
					LDX		#300
					STX		TO_SCREEN_TRANS3D_VIEWZ,PCR

					LBSR	RENDER_CUBE

					LDX		CUBE_DEMO_VRAMADDR,PCR

					LDA		CUBE_DEMO_USEPLT,PCR
					BEQ		CUBEDEMO_LOOP_PALETTE_DONE

					; Due to hardware problem, Blue Plane is not healthy.
					; Avoid Blue Plane in Mode 0
					LDA		#5
					CMPX	#$4000
					BEQ		CUBEDEMO_GREEN_ON ; To draw on Red.  Turn on Green
CUBEDEMO_RED_ON		CLR		$FD39	' 001
					STA		$FD3A	' 010
					STA		$FD3B	' 011
					CLR		$FD3C	' 100
					CLR		$FD3D	' 101
					STA		$FD3E	' 110
					STA		$FD3F	' 111
					BRA		CUBEDEMO_LOOP_PALETTE_DONE
CUBEDEMO_GREEN_ON	CLR		$FD39	' 001
					CLR		$FD3A	' 010
					CLR		$FD3B	' 011
					STA		$FD3C	' 100
					STA		$FD3D	' 101
					STA		$FD3E	' 110
					STA		$FD3F	' 111


CUBEDEMO_LOOP_PALETTE_DONE

					LEAX	$4000,X
					CMPX	#$8000
					BCS		CUBEDEMO_LOOP_NEXTVRAM
					BEQ		CUBEDEMO_LOOP_NEXTVRAM
					LDX		#0
CUBEDEMO_LOOP_NEXTVRAM
					STX		CUBE_DEMO_VRAMADDR,PCR

					LDA		CUBE_DEMO_USEPLT,PCR
					BEQ		CUBEDEMO_LOOP_MOVE

					; Avoid Blue Plane
					CMPX	#0
					BNE		CUBEDEMO_LOOP_MOVE
					LDX		#$4000
					STX		CUBE_DEMO_VRAMADDR,PCR

CUBEDEMO_LOOP_MOVE
					LDA		CUBE_DEMO_VX,PCR
					LDX		TRANS3D_OBJX,PCR
					LEAX	A,X
					STX		TRANS3D_OBJX,PCR
					CMPX	#96
					BGE		CUBEDEMO_FLIP_VX
					CMPX	#-96
					BLE		CUBEDEMO_FLIP_VX
					BRA		CUBEDEMO_VX_DONE
CUBEDEMO_FLIP_VX	NEGA
					STA		CUBE_DEMO_VX,PCR
CUBEDEMO_VX_DONE


					LDA		CUBE_DEMO_CTR,PCR
					LSLA
					LSLA
					LSLA
					STA		SIN_ANGLE,PCR
					LDX		#80
					STX		SIN_MULTIPLIER,PCR
					LBSR	CALC_SIN
					LDX		SIN_MULTIPLIER,PCR
					STX		TRANS3D_OBJY,PCR

CUBEDEMO_MAIN_END	PULS	A,B,X,Y,U
					RTS


RENDER_CUBE			PSHS	A,B,X,Y,U

					LDX		#320
					STX		TO_SCREEN_PERS_CX,PCR
					LDX		#100
					STX		TO_SCREEN_PERS_CY,PCR
					LDA		#8
					STA		TO_SCREEN_PERS_XSHIFT,PCR
					LDA		#7
					STA		TO_SCREEN_PERS_YSHIFT,PCR


					LDX		#0
					STX		TO_SCREEN_WX0,PCR
					STX		TO_SCREEN_WY0
					LDX		#639
					STX		TO_SCREEN_WX1,PCR
					LDX		#199
					STX		TO_SCREEN_WY1,PCR

					LDX		#10
					STX		TO_SCREEN_NEARZ,PCR

					LEAX	CUBE_DATA,PCR
					STX		TO_SCREEN_GEOMDATAADDR,PCR
					LEAX	CUBE_VTX_TFMBUF,PCR
					STX		TO_SCREEN_TFMBUFADDR,PCR

					LDU		#COMMON_LINEBUFPTR
					STU		CALL_LINEDDA_SUBCPU_DATAADDR,PCR

					LDX		CUBE_DEMO_VRAMADDR,PCR
					STX		,U++

					LDA		#80
					STA		,U+		; 80 bytes per line

					LDA		#1
					STA		,U+		; Needs to be one.

					LEAY	0,U
					CLR		,U+		; Number of lines

					STU		TO_SCREEN_LINEOUTADDR,PCR

					LBSR	TO_SCREEN

					LDA		TO_SCREEN_NUMLINE,PCR
					STA		,Y

					LBSR	CALL_CLS_AND_LINEDDA_SUBCPU
RENDER_CUBE_END
					PULS	A,B,X,Y,U
					RTS

